import argparse
import ddddocr
import requests
import yaml
# from PIL import Image
# from io import BytesIO


class Redeem(object):
    def __init__(self, file_name: str = ''):
        self.__config__: dict
        self.__code__: str = ""
        self.__verify_url__: str = ""
        # self.__verify_code__: str = ""
        self.__verify_token__: str = ""
        self.__client__ = requests.Session()

        # 读取配置文件
        with open(file_name, encoding='utf-8') as f:
            self.__config__ = yaml.safe_load(f)

        # 更新 requests session
        self.__client__.headers.update({
            'user-agent': 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/111.0.0.0 '
                          'Safari/537.36'})
        self.__client__.cookies.update(self.__config__['account']['cookies'])

    def nav(self):
        resp = self.__client__.get(url="https://api.bilibili.com/x/web-interface/nav").json()

        name = resp['data']['uname']
        uid = resp['data']['mid']
        vip = resp['data']['vip_label']['text']
        if vip == "":
            vip = "普通用户"

        print(f'当前账号: {name}\tUID: {uid}\t身份: {vip}')

        return self

    def input_token(self):
        self.__code__ = input("请输入兑换码: ")

        return self

    def get_verify_token(self):
        resp = self.__client__.get(url="https://api.bilibili.com/x/vip/code/verify").json()
        self.__verify_url__ = resp['data']['url']
        self.__verify_token__ = resp['data']['token']

        # print(resp)

        return self

    def ocr_verify_token(self):
        image = self.__client__.get(url=self.__verify_url__).content
        ocr = ddddocr.DdddOcr(show_ad=False)
        verify_code = ocr.classification(image)

        # print(verify_code)
        # img = Image.open(BytesIO(image))
        # img.show()

        data = {
            'token': self.__verify_token__,
            'code': self.__code__,
            'mid': self.__config__['account']['cookies']['DedeUserID'],
            'verify': verify_code,
            'csrf': self.__config__['account']['cookies']['BiliJct']
        }

        # print(data)

        resp = self.__client__.post(url="https://api.bilibili.com/x/vip/code/open", data=data).json()
        print(resp)

        if resp['code'] == 69947:
            print('尝试重新获取验证码...')
            self.get_verify_token().ocr_verify_token()

        return self


def main():
    parser = argparse.ArgumentParser()
    parser.add_argument('-c', '--config', type=str, required=False, help='path to the config file',
                        default='config.yaml')
    args = parser.parse_args()

    Redeem(file_name=args.config).nav().input_token().get_verify_token().ocr_verify_token()


if __name__ == "__main__":
    main()
